/*-------------------------------------------------------------------*/
/* ---------------------------CONSULTAS------------------------------*/
/*-------------------------------------------------------------------*/


/* PRIMERA CONSULTA: CANTIDAD DE HERRAMIENTAS ASIGNADAS POR AÑO*/
SELECT
    EXTRACT(year from ASIGNACION.ASIGNACION_FECHA) AS FECHA, EQUIPOS.EQUIPOS_NOMBRE AS NOMBRE_EQUIPO, 
	SUM(ASIGNACION.ASIGNACION_CANTIDAD) AS CANTIDAD_ASIGNADA, COUNT(EQUIPOS.EQUIPOS_ID) AS BOMBEROS_ASIGNADOS
	FROM ASIGNACION
	INNER JOIN EQUIPOS ON EQUIPOS.EQUIPOS_ID = ASIGNACION.EQUIPOS_ID
	GROUP BY FECHA, EQUIPOS.EQUIPOS_ID
	ORDER BY FECHA DESC, EQUIPOS.EQUIPOS_ID ASC;


/* SEGUNDA CONSULTA: CANTIDAD DE ASCENDIDO ORDENADOS POR TIPO DE RANGO Y AÑO*/

SELECT  
	EXTRACT(year from ASCENSO.ASCENSO_FECHA) AS FECHA,
	RANGO.RANGO_NOMBRE AS RANGO_BOMBERO, 
	COUNT(RANGO.RANGO_ID) AS CANTIDAD_ASCENDIDOS
	FROM ASCENSO
	INNER JOIN RANGO ON RANGO.RANGO_ID = ASCENSO.RANGO_ID
	--WHERE RANGO.RANGO_ID = '2'
	GROUP BY FECHA, RANGO.RANGO_ID 
	ORDER BY FECHA DESC, RANGO.RANGO_ID ASC;
   
   
/* TERCERA CONSULTA: CANTIDAD DE CAPACITACIONES POR AÑO Y BOMBEROS*/
SELECT
    BOMBERO.BOMBERO_NOMBRE AS NOMBRE_BOMBERO, EXTRACT(year from CAPACITACIONES.CAPACITACIONES_FECHA) AS FECHA, 
	COUNT(CAPACITACIONES.CAPACITACIONES_ID) AS CANTIDAD_CAPACITACIONES
	FROM CAPACITACIONES
	INNER JOIN BOMBERO ON BOMBERO.BOMBERO_ID = CAPACITACIONES.BOMBERO_ID	
	--WHERE BOMBERO.BOMBERO_ID = '1002'	
	GROUP BY FECHA, BOMBERO.BOMBERO_NOMBRE
	ORDER BY FECHA DESC;
   

/* CUARTA CONSULTA: DONACIONES REALIZADAS POR EMPRESA ORDENADAS POR AÑO*/
SELECT
    EXTRACT(year from INGRESO_EQUIPOS.INGRESO_FECHA) AS FECHA, ORIGEN_EQUIPOS.ORIGEN_NOMBRE AS NOMBRE_DONANTE, 
	EQUIPOS.EQUIPOS_NOMBRE AS NOMBRE_EQUIPO, INGRESO_EQUIPOS.INGRESO_CANTIDAD AS CANTIDAD
	FROM INGRESO_EQUIPOS
	INNER JOIN ORIGEN_EQUIPOS ON ORIGEN_EQUIPOS.ORIGEN_ID = INGRESO_EQUIPOS.ORIGEN_ID	
	INNER JOIN EQUIPOS ON EQUIPOS.EQUIPOS_ID = INGRESO_EQUIPOS.EQUIPOS_ID
	ORDER BY FECHA DESC;
	
	
	
	
	
/*
|||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||
---------------------------------------TRIGGERS
|||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||
*/

CREATE FUNCTION ASIGNAR_EQUIPOS() RETURNS TRIGGER AS $ASIGNAR_EQUIPOS$
DECLARE
	CANTIDAD INTEGER;
BEGIN
	SELECT (ASIGNACION_CANTIDAD) INTO CANTIDAD FROM ASIGNACION 
	--Si el codigo del ide es igual al codigo ingresado y si el id del bombero es igual al id ingresado
	WHERE EQUIPOS_ID=NEW.EQUIPOS_ID AND BOMBERO_ID=NEW.BOMBERO_ID;
	IF (CANTIDAD > 0) THEN
		RAISE EXCEPTION 'EL BOMBERO YA TIENE ASIGNAODO UN EQUIPO';
	END IF;
	RETURN NEW;	 
END;
$ASIGNAR_EQUIPOS$ LANGUAGE plpgsql;

--Creacion del Trigger
CREATE TRIGGER PR_ASIGNACION 
BEFORE INSERT ON ASIGNACION FOR EACH ROW
EXECUTE PROCEDURE ASIGNAR_EQUIPOS();

------EJEMPLO NO VALIDO 
INSERT INTO ASIGNACION VALUES('19','021','1002','15','2021-11-15');

------EJEMPLO NO VALIDO 
INSERT INTO ASIGNACION VALUES('19','021','1003','15','2021-11-15');

/*
|||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||
---------------------------------------CURSOR
|||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||
*/

--------------CAPACITACIONES POR AÑO
DO $$
DECLARE 
	INFORMACION RECORD;
	--Creacuon del cursor explicito
	C_CAP_ASIG CURSOR FOR SELECT 
		BOMBERO_NOMBRE AS NOMBRE_BOMBERO,
		EXTRACT(year from CAPACITACIONES.CAPACITACIONES_FECHA) AS FECHA_CAP, 
		COUNT(CAPACITACIONES.CAPACITACIONES_ID) AS CANTIDAD_CAP
	FROM 
		PUBLIC.BOMBERO
		INNER JOIN PUBLIC.CAPACITACIONES ON CAPACITACIONES.BOMBERO_ID = BOMBERO.BOMBERO_ID
	GROUP BY
		BOMBERO_NOMBRE,
		EXTRACT(year from CAPACITACIONES.CAPACITACIONES_FECHA)
	ORDER BY 
		EXTRACT(year from CAPACITACIONES.CAPACITACIONES_FECHA) DESC;

BEGIN
	FOR INFORMACION IN C_CAP_ASIG LOOP
		RAISE NOTICE 'EL BOMBERO %, REALIZO EN EL AÑO %, LA CANTIDAD DE %, CAPACITACIONES ESE AÑO.',
		INFORMACION.NOMBRE_BOMBERO, INFORMACION.FECHA_CAP, INFORMACION.CANTIDAD_CAP;
	END LOOP;
END $$
LANGUAGE plpgsql;

--------------ASIGNACIONES POR AÑO
DO $$
DECLARE 
	INFORMACION RECORD;
	C_CAP_ASIG CURSOR FOR SELECT 
		BOMBERO_NOMBRE AS NOMBRE_BOMBERO,
		EXTRACT(year from ASIGNACION.ASIGNACION_FECHA) AS FECHA_ASIG, 
		COUNT(ASIGNACION.ASIGNACION_ID) AS CANTIDAD_ASIG
	FROM 
		PUBLIC.BOMBERO
		INNER JOIN PUBLIC.ASIGNACION ON ASIGNACION.BOMBERO_ID = BOMBERO.BOMBERO_ID
	GROUP BY
		BOMBERO_NOMBRE,
		EXTRACT(year from ASIGNACION.ASIGNACION_FECHA)
	ORDER BY 
		BOMBERO_NOMBRE ASC,
		EXTRACT(year from ASIGNACION.ASIGNACION_FECHA) DESC;

BEGIN
	FOR INFORMACION IN C_CAP_ASIG LOOP
		RAISE NOTICE 'AL BOMBERO % SE LE ASIGNO EN EL AÑO % LA CANTIDAD DE % EQUIPOS.',
		INFORMACION.NOMBRE_BOMBERO, INFORMACION.FECHA_ASIG, INFORMACION.CANTIDAD_ASIG;
	END LOOP;
END $$
LANGUAGE plpgsql;

--------------CANTIDAD DE CAPACITACIONES Y ASIGNACIONES POR CODIGO DEL BOMBERO
DO $$
DECLARE 
	CODIGO INT=1001;
	INFORMACION RECORD;
	CONT INT;
	V1 INT=0; 
	V2 INT=0;
	----CURSOR DE CAPACITACIONES
	C_CAP CURSOR IS SELECT *
	FROM BOMBERO
	INNER JOIN CAPACITACIONES ON BOMBERO.BOMBERO_ID = CAPACITACIONES.BOMBERO_ID
	WHERE CAPACITACIONES.BOMBERO_ID = CODIGO;	
	----CURSOR DE ASIGNACIONES
	C_ASIG CURSOR IS SELECT * 
	FROM BOMBERO
	INNER JOIN ASIGNACION ON BOMBERO.BOMBERO_ID = ASIGNACION.BOMBERO_ID
	WHERE ASIGNACION.BOMBERO_ID = CODIGO;
BEGIN
   FOR CONT IN C_CAP LOOP
		V1 = V1 + COUNT(CONT.CAPACITACIONES_ID);
	END LOOP;
	FOR CONT IN C_ASIG LOOP
		V2 = V2 + COUNT(CONT.ASIGNACION_ID);
	END LOOP;
	OPEN C_ASIG;
	FETCH C_ASIG INTO INFORMACION;
	RAISE NOTICE 
	 'El bombero % % del Districto #% del Cuerpo de Bombero tiene;
	   - Una cantidad de % equipos asignados 
	   - Un total de % capacitaciones realizadas.
	   ', INFORMACION.BOMBERO_NOMBRE, INFORMACION.BOMBERO_APELLIDO, INFORMACION.DISTRITO_ID, V2, V1;
END $$
LANGUAGE plpgsql;

--------------CANTIDAD DE ASIGNACIONES Y CAPACITACIONES POR AÑO (NO FUNCUONA)
DO $$
DECLARE 
	INFORMACION RECORD;
	C_CAP_ASIG CURSOR FOR SELECT 
		BOMBERO_NOMBRE AS NOMBRE_BOMBERO,
		EXTRACT(year from ASIGNACION.ASIGNACION_FECHA) AS FECHA_ASIG, 
		COUNT(ASIGNACION.ASIGNACION_ID) AS CANTIDAD_ASIG,
		EXTRACT(year from CAPACITACIONES.CAPACITACIONES_FECHA) AS FECHA_CAP, 
		COUNT(CAPACITACIONES.CAPACITACIONES_ID) AS CANTIDAD_CAP
	FROM 
		PUBLIC.BOMBERO
		INNER JOIN PUBLIC.ASIGNACION ON ASIGNACION.BOMBERO_ID = BOMBERO.BOMBERO_ID
		INNER JOIN PUBLIC.CAPACITACIONES ON CAPACITACIONES.BOMBERO_ID = BOMBERO.BOMBERO_ID
	GROUP BY
		BOMBERO_NOMBRE,
		EXTRACT(year from ASIGNACION.ASIGNACION_FECHA),
		EXTRACT(year from CAPACITACIONES.CAPACITACIONES_FECHA)
	ORDER BY 
		EXTRACT(year from ASIGNACION.ASIGNACION_FECHA) DESC,
		EXTRACT(year from CAPACITACIONES.CAPACITACIONES_FECHA) DESC;

BEGIN
	FOR INFORMACION IN C_CAP_ASIG LOOP
	---FETCH C_CAP_ASIG INTO INFORMACION;
		RAISE NOTICE 
					'NOMBRE: % 
					 AÑO: %, CANTIDAD EQUIPOS: %
					 AÑO: %, CANTIDAD CURSOS: %
					', INFORMACION.NOMBRE_BOMBERO, INFORMACION.FECHA_ASIG, INFORMACION.CANTIDAD_ASIG, INFORMACION.FECHA_CAP, INFORMACION.CANTIDAD_CAP;							
	END LOOP;
END $$
LANGUAGE plpgsql;

--------------CANTIDAD DE ASIGNACIONES Y CAPACITACIONES POR AÑO (NO FUNCUONA)
DO $$
DECLARE 
	INFORMACION RECORD;
	CONT INT;
	V1 INT=0; 
	V2 INT=0;
	----CURSOR DE ASIGNACIONES
	C_ASIG CURSOR FOR SELECT 
		BOMBERO.BOMBERO_NOMBRE AS NOMBRE,
		EXTRACT(year from ASIGNACION.ASIGNACION_FECHA) AS FECHA_ASIG, 
		COUNT(ASIGNACION.ASIGNACION_ID) AS CANTIDAD_ASIG
	FROM ASIGNACION
	INNER JOIN BOMBERO ON BOMBERO.BOMBERO_ID = ASIGNACION.BOMBERO_ID
	GROUP BY
		EXTRACT(year from ASIGNACION.ASIGNACION_FECHA), NOMBRE
	ORDER BY 
		EXTRACT(year from ASIGNACION.ASIGNACION_FECHA) DESC;
	----CURSOR DE CAPACITACIONES
	C_CAP CURSOR FOR SELECT 		
		EXTRACT(year from CAPACITACIONES.CAPACITACIONES_FECHA) AS FECHA_CAP, 
		COUNT(CAPACITACIONES.CAPACITACIONES_ID) AS CANTIDAD_CAP
	FROM CAPACITACIONES
	INNER JOIN BOMBERO ON BOMBERO.BOMBERO_ID = CAPACITACIONES.BOMBERO_ID
	GROUP BY
		EXTRACT(year from CAPACITACIONES.CAPACITACIONES_FECHA)
	ORDER BY 
		EXTRACT(year from CAPACITACIONES.CAPACITACIONES_FECHA) DESC;

BEGIN
	FOR CONT IN C_ASIG LOOP
		V1 = V1 + COUNT(CONT.ASIGNACION_ID);
	END LOOP;
	FOR CONT IN C_CAP LOOP
		V1 = V1 + COUNT(CONT.CAPACITACIONES_ID);
	END LOOP;
	FOR INFORMACION IN C_ASIG LOOP
	OPEN C_ASIG;
	FETCH C_ASIG INTO INFORMACION;
		RAISE NOTICE 
					'NOMBRE: % 
					 AÑO: %, CANTIDAD EQUIPOS: %
					 AÑO: %, CANTIDAD CURSOS: %
					', INFORMACION.NOMBRE_BOMBERO, INFORMACION.FECHA_ASIG, V1, INFORMACION.FECHA_CAP, V2;							
	END LOOP;
END $$
LANGUAGE plpgsql;

/*
|||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||
---------------------------------------PROCESO
|||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||
QUE INGRESE UN BOMBERO Y QUE MUESTRE LAS CAPACITACIONES QUE HA REALIZADO POR AÑO
*/

CREATE OR REPLACE FUNCTION BOMBERO_CAPACITACIONES (INTEGER)
	RETURNS SETOF RECORD 
	AS 
	$BODY$
		SELECT BOMBERO.BOMBERO_NOMBRE, 
		EXTRACT(YEAR FROM CAPACITACIONES_FECHA),
		COUNT(CAPACITACIONES_ID)
		FROM CAPACITACIONES
		INNER JOIN BOMBERO ON BOMBERO.BOMBERO_ID = CAPACITACIONES.BOMBERO_ID
		WHERE CAPACITACIONES.BOMBERO_ID = $1
		GROUP BY 
			BOMBERO.BOMBERO_NOMBRE,
			EXTRACT(YEAR FROM CAPACITACIONES_FECHA);
	$BODY$
	LANGUAGE SQL; 
	
	SELECT * FROM BOMBERO_CAPACITACIONES (1002)
	AS ("BOMBERO_NOMBRE" VARCHAR, "AÑO" INTEGER, "CAPACITACIONES" INTEGER);
	
	
	
/*
|||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||
---------------------------------------REPORT
|||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||
QUE MUESTRE LA CANTIDAD DE INCIDENTES OCURRIDOS POR LUGARES. Y POR AÑO?
SANTHA MARTE - 2 INCIDENTES
PLMAR 5 INCIDENTES
*/

SELECT  
	EXTRACT(year from INCIDENTE.INCIDENTE_FECHA) AS FECHA, 
	CANTON_UBICACION.CANTON_NOMBRE AS CANTON,
	SECTOR_UBICACION.SECTOR_NOMBRE AS SECTOR,	
	COUNT(UBICACION.SECTOR_ID) AS CANTIDAD	
	FROM INCIDENTE
	INNER JOIN UBICACION ON UBICACION.UBICACION_ID = INCIDENTE.UBICACION_ID
	INNER JOIN CANTON_UBICACION ON CANTON_UBICACION.CANTON_ID = UBICACION.CANTON_ID
	INNER JOIN SECTOR_UBICACION ON SECTOR_UBICACION.SECTOR_ID = UBICACION.SECTOR_ID
	GROUP BY FECHA, UBICACION.SECTOR_ID, CANTON_UBICACION.CANTON_NOMBRE, SECTOR_UBICACION.SECTOR_NOMBRE
	ORDER BY FECHA DESC, UBICACION.SECTOR_ID ASC;

